﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using RidePal.Data.Models;
using RidePal.Services.Contracts;
using RidePal.Services.DTOs;
using RidePal.Web.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;


namespace RidePal.Web.Controllers
{
    [Authorize(Roles = "Admin, User")]
    public class UserPlaylistController : Controller
    {
        private readonly ILogger<HomeController> logger;
        private readonly UserManager<User> userManager;
        private readonly IUserPlaylistService userPlaylistService;

        public UserPlaylistController(ILogger<HomeController> logger, IUserPlaylistService userPlaylistService, UserManager<User> userManager)
        {
            this.logger = logger;
            this.userManager = userManager ?? throw new ArgumentNullException(nameof(userManager));
            this.userPlaylistService = userPlaylistService ?? throw new ArgumentNullException(nameof(userPlaylistService));
        }

        // GET: UserPlaylist
        public async Task<IActionResult> Index(int? itemsCount, int? pageNumber)
        {
            var userId = int.Parse(this.userManager.GetUserId(this.User));
            ViewBag.playlistCount = await userPlaylistService.GetPlaylistsForUserCountAsync(userId);

            var playlistDTOs = await this.userPlaylistService.GetPlaylistsForUserAsync(userId, itemsCount.HasValue ? itemsCount.Value : 5, pageNumber.HasValue ? pageNumber.Value : 1);
            var result = playlistDTOs.Select(x => new PlaylistViewModel(x));

            return View(result);
        }

        // GET: UserPlaylist/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: UserPlaylist/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(GeneratePlaylistViewModel playlist)
        {
            var tuple1 = Tuple.Create("Rock", playlist.Percentage1);
            var tuple2 = Tuple.Create("Metal", playlist.Percentage2);
            var tuple3 = Tuple.Create("Jazz", playlist.Percentage3);
            var tuple4 = Tuple.Create("Classical", playlist.Percentage4);
            var tuple5 = Tuple.Create("Rap/Hip Hop", playlist.Percentage5);
            List<Tuple<string, int>> tempTupleList = new List<Tuple<string, int>> { tuple1, tuple2, tuple3, tuple4, tuple5 };
            List<Tuple<string, int>> tupleList = new List<Tuple<string, int>>();
            for (int i = 0; i < tempTupleList.Count; i++)
            {
                if (tempTupleList[i].Item2 > 0)
                {
                    tupleList.Add(tempTupleList[i]);
                }
            }

            var userId = int.Parse(this.userManager.GetUserId(this.User));

            PlaylistDTO playlistDTO = null;
            if (ModelState.IsValid)
            {
                try
                {
                    playlistDTO = await this.userPlaylistService.GeneratePlaylistAsync(tupleList, playlist.StartPoint, playlist.EndPoint,
                                                                         playlist.Title, userId);
                }
                catch (Exception)
                {
                    return View("Views/Home/BadRequest.cshtml");
                }

                logger.LogInformation("Playlist with title {0} was generated by user with id: {1}.", playlist.Title, userId);
                return RedirectToAction("Details", "Playlist", new { id = playlistDTO.Id });
            }

            return View(playlistDTO);
        }

        // GET: UserPlaylist/Edit/5
        public async Task<IActionResult> Edit(int id)
        {
            if (id < 1)
            {
                return View("Views/Home/BadRequest.cshtml");
            }

            var userId = int.Parse(this.userManager.GetUserId(this.User));
            PlaylistDTO playlist = null;
            try
            {
                playlist = await this.userPlaylistService.GetPlaylistAsync(id);
            }
            catch (Exception)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            if (playlist.UserId != userId && userId != 1)
            {
                return View("Views/Home/Forbidden.cshtml");
            }
            var result = new PlaylistViewModel(playlist);
            return View(result);
        }

        // POST: UserPlaylist/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(PlaylistViewModel playlist)
        {
            if (ModelState.IsValid)
            {
                var result = await this.userPlaylistService.EditPlaylistAsync(playlist.Id, playlist.Title);
                if (result == true)
                {
                    logger.LogInformation("Playlist with id: {0}'s name was edited to {1}.", playlist.Id, playlist.Title);
                    return RedirectToAction(nameof(Index));
                }

                return View("Views/Home/BadRequest.cshtml");
            }
            return View(playlist);
        }

        // GET: UserPlaylist/Delete/5
        public async Task<IActionResult> Delete(int id)
        {
            if (id < 1)
            {
                return View("Views/Home/BadRequest.cshtml");
            }

            var userId = int.Parse(this.userManager.GetUserId(this.User));
            PlaylistDTO playlist = null;
            try
            {
                playlist = await this.userPlaylistService.GetPlaylistAsync(id);
            }
            catch (Exception)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            if (playlist.UserId != userId && userId != 1)
            {
                return View("Views/Home/Forbidden.cshtml");
            }
            var result = new PlaylistViewModel(playlist);
            return View(result);
        }

        // POST: UserPlaylist/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var result = await this.userPlaylistService.DeletePlaylistAsync(id);

            if (result == true)
            {
                logger.LogInformation("Playlist with id: {0} was deleted.", id);
                return RedirectToAction(nameof(Index));
            }
            else
            {
                return View("Views/Home/BadRequest.cshtml");
            }
        }
    }
}
